<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlaceIdentifier_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlaceIdentifier_V3 extends AbstractStructArrayBase
{
    /**
     * The PlaceIdentifier_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlaceIdentifier_V3[]
     */
    public $PlaceIdentifier_V3;
    /**
     * Constructor method for ArrayOfPlaceIdentifier_V3
     * @uses ArrayOfPlaceIdentifier_V3::setPlaceIdentifier_V3()
     * @param \StructType\PlaceIdentifier_V3[] $placeIdentifier_V3
     */
    public function __construct(array $placeIdentifier_V3 = array())
    {
        $this
            ->setPlaceIdentifier_V3($placeIdentifier_V3);
    }
    /**
     * Get PlaceIdentifier_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlaceIdentifier_V3[]|null
     */
    public function getPlaceIdentifier_V3()
    {
        return isset($this->PlaceIdentifier_V3) ? $this->PlaceIdentifier_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlaceIdentifier_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlaceIdentifier_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlaceIdentifier_V3ForArrayConstraintsFromSetPlaceIdentifier_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlaceIdentifier_V3PlaceIdentifier_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfPlaceIdentifier_V3PlaceIdentifier_V3Item instanceof \StructType\PlaceIdentifier_V3) {
                $invalidValues[] = is_object($arrayOfPlaceIdentifier_V3PlaceIdentifier_V3Item) ? get_class($arrayOfPlaceIdentifier_V3PlaceIdentifier_V3Item) : sprintf('%s(%s)', gettype($arrayOfPlaceIdentifier_V3PlaceIdentifier_V3Item), var_export($arrayOfPlaceIdentifier_V3PlaceIdentifier_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlaceIdentifier_V3 property can only contain items of type \StructType\PlaceIdentifier_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlaceIdentifier_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceIdentifier_V3[] $placeIdentifier_V3
     * @return \ArrayType\ArrayOfPlaceIdentifier_V3
     */
    public function setPlaceIdentifier_V3(array $placeIdentifier_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($placeIdentifier_V3ArrayErrorMessage = self::validatePlaceIdentifier_V3ForArrayConstraintsFromSetPlaceIdentifier_V3($placeIdentifier_V3))) {
            throw new \InvalidArgumentException($placeIdentifier_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($placeIdentifier_V3) || (is_array($placeIdentifier_V3) && empty($placeIdentifier_V3))) {
            unset($this->PlaceIdentifier_V3);
        } else {
            $this->PlaceIdentifier_V3 = $placeIdentifier_V3;
        }
        return $this;
    }
    /**
     * Add item to PlaceIdentifier_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceIdentifier_V3 $item
     * @return \ArrayType\ArrayOfPlaceIdentifier_V3
     */
    public function addToPlaceIdentifier_V3(\StructType\PlaceIdentifier_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlaceIdentifier_V3) {
            throw new \InvalidArgumentException(sprintf('The PlaceIdentifier_V3 property can only contain items of type \StructType\PlaceIdentifier_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlaceIdentifier_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlaceIdentifier_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlaceIdentifier_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlaceIdentifier_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlaceIdentifier_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlaceIdentifier_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlaceIdentifier_V3
     */
    public function getAttributeName()
    {
        return 'PlaceIdentifier_V3';
    }
}
